#! /bin/bash

cd ~/scan

kdialog --msgbox "To perform the analysis, three files will be required by the application:\n\n - a file to analyse, \n - a file containing the right answers, \n - a 'list' file, normally placed in the 'tasks' folder' of the SCAN."

tocheck=$(kdialog --getopenfilename ~/scan/results --title "Please, select a file to analyse")
reference=$(kdialog --getopenfilename ~/scan --title "Please, select a file, contaning the correct answers")
list=$(kdialog --getopenfilename ~/scan/tasks/list --title "Select the 'list' file")

name=$(cat $tocheck | head -n1)

echo $name > temp/$name/$name

# create the appropriate directories

if [ ! -d temp/checker/ ]
	then
		if [ -d temp ]
			then
				echo "temp exists"
				mkdir temp/checker/
			else
				mkdir temp
				mkdir temp/checker
		fi
fi


#for i in $(cat $reference | tr '\r\n' '+' | grep -v "kalib" | sed s'/++/\n/'g | cut -d"|" -f1); do
#	if [ ! -d temp/checker/$i ]
#		then
#			mkdir temp/checker/$i
#	fi
#done



for i in $(cat $list| cut -d"|" -f1); do
	if [ ! -d temp/checker/$i ]
		then
			mkdir temp/checker/$i
	fi
done

if [ ! -d temp/reference ]
	then
		mkdir temp/reference
fi

if [ ! -d temp/$name ]
	then
		mkdir temp/$name
fi

for i in $(ls temp/checker | grep -v "reference");do

	if [ ! -d temp/reference/$i ]
		then
			mkdir temp/reference/$i
	fi
	
#	cat $reference | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f2 > temp/reference/$i/olvasasido_1
	cat $reference | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f3 > temp/reference/$i/valasz_1
	cat $reference | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f4 > temp/reference/$i/valaszido_1
	cat $reference | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f5 > temp/reference/$i/valasz_2
	cat $reference | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f6 > temp/reference/$i/valaszido_2
done

for i in $(ls temp/checker | grep -v "reference"); do

#	cat $tocheck | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f2 > temp/checker/$i/olvasasido_1
	cat $tocheck | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f3 > temp/checker/$i/valasz_1
	cat $tocheck | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f4 > temp/checker/$i/valaszido_1
	cat $tocheck | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f5 > temp/checker/$i/valasz_2
	cat $tocheck | tr '\r\n' '+' | sed s'/++/\n/'g | grep "$i|" | cut -d+ -f6 > temp/checker/$i/valaszido_2
done

#válaszok értékelése

echo $name
echo
echo "helyes válaszok aránya (százalékban)"
	echo >> temp/$name/$name
	echo "helyes válaszok aránya (százalékban)" >> temp/$name/$name


hossz=0
teljes_hossz=0
right_all=0
for i in $(ls temp/checker | grep -v "k-"); do
	int=0
	unset right_answer
	for j in $(ls temp/checker/$i | grep -v "ido");do
		for k in $(cat temp/checker/$i/$j | grep [a-z,0-9]); do
			check_from=$(head -n$(($int + 1)) temp/reference/$i/$j | tail -n1)
			check_to=$(head -n$(($int + 1)) temp/checker/$i/$j | tail -n1)
			if [[ $check_from = $check_to ]]
				then
					right_answer=$(($right_answer + 1))
					hossz=$(($int + 1))
			fi
			int=$(($int + 1))
		done

	##################
	#Kellene valami adat a plot-hoz, hogy a megfelelő helyre rakja ki az adott személy eredményét mutató jelet...
	##################


	z=$(cat main/factors/$i | head -n2 | tail -n1)
	k=$(cat main/factors/$i | head -n3 | tail -n1)
	
	time_average=$(cat main/factors/$i | head -n4 | tail -n1)
	time_stdev=$(cat main/factors/$i | head -n5 | tail -n1)
	
	if [ $right_percent -eq 100 ]
		then
			x=1
		else
			x=$(echo "0.$right_percent")
	fi
	half=$(cat main/factors/$i | head -n6 | tail -n1)
	
	echo "#! /usr/bin/gnuplot" > main/plot.sh

	echo "unset yrange" >> main/plot.sh
	echo "unset key" >> main/plot.sh
	echo "unset title" >> main/plot.sh
	echo "set border 1+2" >> main/plot.sh
	echo "set terminal png size 1200,600 enhanced font 'Helvetica,10'" >> main/plot.sh
	echo "set output 'temp/$name/$name.$i.png'" >> main/plot.sh
	echo "set size ratio -1" >> main/plot.sh
	echo "set yrange [0:1]" >> main/plot.sh
	echo "set xrange [0:1.001]" >> main/plot.sh
	echo "set key off" >> main/plot.sh
	echo "set style rectangle back fc rgb '#ddeedd' fs solid 1.0 noborder" >> main/plot.sh
	echo "set obj  1 rect from $half,0 to 1,1 fs solid fc rgb '#ddeedd' back" >> main/plot.sh

	echo "set title 'Name; $name'" >> main/plot.sh
	echo "set arrow 1 from $x,0 to $x,1 nohead lc rgb '#449944' lw 3" >> main/plot.sh
	echo "k=$k" >> main/plot.sh
	echo "z=$z" >> main/plot.sh
	echo "f(x) = k*(x **z)" >> main/plot.sh
	echo "plot f(x) with lines linestyle 1 lw 3 lc rgb 'red'" >> main/plot.sh
	
	main/plot.sh

#####################

	done
	right_all=$(($right_all + $right_answer))
	teljes_hossz=$(($teljes_hossz + $hossz))
	right_percent=$(((($right_answer *10000)/($hossz *10))/10))
	final_percent=$((  (($right_all * 10000 )/($teljes_hossz *10))/10  ))
	echo "   $i $right_percent%"
	echo "   $i $right_percent%" >> temp/$name/$name
done

#válaszidők átlagolása

echo
echo "válaszidő átlagok (tized másodpercekben)"
	echo >> temp/$name/$name
	echo "válaszidő átlagok (tized másodpercekben)" >> temp/$name/$name

unset osszes_ido
unset osszes_ido_atlag
unset int_sum
for i in $(ls temp/checker | grep -v "k-"); do
	int=1
	unset ido_atlag
	for j in $(ls temp/checker/$i | grep "ido");do
		for k in $(cat temp/checker/$i/$j | grep [a-z,0-9]); do
			ido_atlag=$(( (($ido_atlag + $k)/$int)/10000000 ))
			osszes_ido=$(( $osszes_ido + $k ))
			int_sum=$(( $int_sum + $int ))
			osszes_ido_atlag=$(( ($osszes_ido/$int_sum)/10000000 ))
			int=$(($int + 1))
		#done
		
##################
## Idő normáleloszlás kirajzolása
##################	

	time_average=$(cat main/factors/$i | head -n4 | tail -n1)
	time_stdev=$(cat main/factors/$i | head -n5 | tail -n1)
	if [ $(echo $ido_atlag | grep [0-9][0-9][0-9]) ]
		then
			w1=$(echo $ido_atlag | cut -c1)
			w2=$(echo $ido_atlag | cut -c2)
			w3=$(echo $ido_atlag | cut -c3)
			x=$(echo "$w1$w2.$w3")
		else
			if [ $(echo $ido_atlag | grep [0-9][0-9]) ]
				then
					w1=$(echo $ido_atlag | cut -c1)
					w2=$(echo $ido_atlag | cut -c2)
					x=$(echo "$w1.$w2")
				else
					w1=$(echo $ido_atlag | cut -c1)
					x=$(echo "0.$w1")
			fi
	fi

				
	echo "#! /usr/bin/gnuplot" > main/plot.sh
	echo "unset yrange" >> main/plot.sh
	echo "unset key" >> main/plot.sh
	echo "unset title" >> main/plot.sh
	echo "set border 1+2" >> main/plot.sh
	echo "set terminal png size 1200,600 enhanced font 'Helvetica,10'" >> main/plot.sh
	echo "set output 'temp/$name/$name.$i.time.png'" >> main/plot.sh
	echo "set yrange [0:0.4]" >> main/plot.sh
	echo "set xrange [0:60]" >> main/plot.sh
	echo "set key off" >> main/plot.sh
	echo "set title 'Name; $name'" >> main/plot.sh
	echo "set arrow 1 from $x,0 to $x,1 nohead lc rgb '#449944' lw 3" >> main/plot.sh
	echo " " >> main/plot.sh
	echo "t=$time_average" >> main/plot.sh
	echo "s=$time_stdev" >> main/plot.sh
	echo "f(x)=(1/(s*(sqrt(2*3.1415927))))*(2.71828183**(-1 *(((x-t)**2)/(2*(s**2)))))" >> main/plot.sh
	echo "plot f(x) with lines linestyle 1 lw 3 lc rgb 'red'" >> main/plot.sh

	main/plot.sh
	done
	done
	echo "   $i $ido_atlag"
	echo "   $i $ido_atlag" >> temp/$name/$name
done 

control_answer=$(cat main/averages/sum | cut -d"|" -f2)
control_time=$(cat main/averages/sum | cut -d"|" -f1)

related_answer=$(( (($final_percent * 1000)/$control_answer)/10 ))
related_time=$(( (($osszes_ido_atlag * 1000)/$control_time)/10  ))

echo
echo "összesített eredmények"
echo
echo "   Helyes válaszok száma és aránya összesen (százalékban): $right_all $final_percent%"
echo "   Helyes válaszok aránya a normál kontroll százalékban: $related_answer"
echo "   Összes kérdés: $teljes_hossz"
echo "   Átlagos válaszidő (tized másodpercekben): $osszes_ido_atlag"
echo "   Átlagos válaszidő a normál kontroll százalékban: $related_time"
echo

	echo >> temp/$name/$name
	echo "összesített eredmények" >> temp/$name/$name
	echo >> temp/$name/$name
	echo "   Helyes válaszok száma és aránya összesen (százalékban): $right_all $final_percent%" >> temp/$name/$name
	echo "   Helyes válaszok aránya a normál kontroll százalékában: $related_answer" >> temp/$name/$name
	echo "   Összes kérdés: $teljes_hossz" >> temp/$name/$name
	echo "   Átlagos válaszidő (tized másodpercekben): $osszes_ido_atlag" >> temp/$name/$name
	echo "   Átlagos válaszidő a normál kontroll százalékában: $related_time" >> temp/$name/$name

	plot_time=$(($related_time))
	plot_answer=$(($related_answer))
	echo "$plot_time, $plot_answer" > main/plotting_data/current_data
	
################################
## diagram plotting
################################

echo "#! /usr/bin/gnuplot" > main/plot.sh
echo >> main/plot.sh
echo "unset yrange" >> main/plot.sh
echo "unset key" >> main/plot.sh
echo "unset title" >> main/plot.sh
echo "set terminal png size 1200,600 enhanced font 'Helvetica,10'" >> main/plot.sh
echo "set output '~/scan/temp/$name/$name.png'" >> main/plot.sh
echo "set size ratio -1" >> main/plot.sh
echo "set yrange [0:120]" >> main/plot.sh
echo "set xrange [0:420]" >> main/plot.sh
echo "set key off" >> main/plot.sh
echo >> main/plot.sh
echo "#set object circle at first 120,85 radius char 0.5 fillstyle empty border lc rgb '#000000' lw 3" >> main/plot.sh
echo >> main/plot.sh
#echo "set title name; '$name; orange line: control group's 100%; Blue: control persons, Orange: ill persons'" >> main/plot.sh
echo "set arrow 1 from 100.0 to 100,120 nohead lc rgb 'orange' lw 3" >> main/plot.sh
echo "set arrow 2 from 0,100 to 420,100 nohead lc rgb 'orange' lw 3" >> main/plot.sh
echo "set label 'A' at 25,110" >> main/plot.sh
echo "set label 'B' at 250,110" >> main/plot.sh
echo "set label 'C' at 25,20" >> main/plot.sh
echo "set label 'D' at 250,20" >> main/plot.sh
echo >> main/plot.sh
echo "set object circle at first 26.3,110 radius char 2 fillstyle empty border lc rgb '#000000' lw 1" >> main/plot.sh
echo "set object circle at first 251.3,110 radius char 2 fillstyle empty border lc rgb '#000000' lw 1" >> main/plot.sh
echo "set object circle at first 26.3,20 radius char 2 fillstyle empty border lc rgb '#000000' lw 1" >> main/plot.sh
echo "set object circle at first 251.3,20 radius char 2 fillstyle empty border lc rgb '#000000' lw 1" >> main/plot.sh
echo >> main/plot.sh
echo "plot 'main/plotting_data/scan_plot' using 1:2 with points pointtype 6 ps 0.6 lc rgb 'blue','main/plotting_data/scan_plot' using 1:3 with points ps 1 pointtype 7 lc rgb 'red','main/plotting_data/current_data' using 1:2 with points pointtype 3 lw 2 ps 2 lc rgb 'black'" >> main/plot.sh

main/plot.sh

##########################
## display results
##########################

kdialog --textbox "temp/$name/$name" --geometry 500x600+50+50

kdialog --textinputbox "<img src=temp/$name/$name.png>"

kdialog --msgbox "All results are saved to the scan/temp folder, using the name: $name"

###########
## mopping up
###########
rm -rf temp/checker
rm -rf temp/reference

exit